NANOSLEEP(2)

NAME
nanosleep, signanosleep

SYNOPSIS
#include <time.h>
int
nanosleep(const struct timespec *rqtp, struct timespec *rmtp);

#include <signal.h>
#include <time.h>
int
signanosleep(const struct timespec *rqtp, struct timespec *rmtp, sigset_t *mask);

DESCRIPTION
Nanosleep() causes the process to sleep for the specified time. An unmasked signal will cause it to terminate the sleep early, regardless of the SA_RESTART value on the interrupting signal.

The signanosleep() function temporarily (and atomically) sets the signal mask of the process for the duration of the system call so that specific signals can be nominated to cause an early termination of the sleep.

RETURN VALUE
If the nanosleep() function returns because the requested time has elapsed, the value returned will be zero.

If the nanosleep() function returns due to the delivery of a signal, the value returned will be the -1, and the global variable errno will be set to indicate the interruption. If rmtp is non-NULL, the timespec structure it references is updated to contain the unslept amount (the request time minus the time actually slept).

ERRORS
If any of the following conditions occur, the nanosleep function shall return -1 and set errno to the corresponding value.

[EFAULT]
    Either rqtp or rmtp points to memory that is not a valid part of the process address space.

[EINTR]
    nanosleep was interrupted by the delivery of a signal.

[EINVAL]
    rqtp specified a nanosecond value less than zero or greater than 1000 million.

[ENOSYS]
    nanosleep is not supported by this implementation.

SEE ALSO
sigsuspend(2) sleep(3)

STANDARDS
The nanosleep() function conforms to p1003.1b-93.

The signanosleep() function is an extenstion that first appeared in FreeBSD 3.0